Index: drivers/serial/tsuart.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart.c,v
retrieving revision 1.1
retrieving revision 1.9
diff -u -r1.1 -r1.9
--- drivers/serial/tsuart.c	17 Nov 2005 22:27:57 -0000	1.1
+++ drivers/serial/tsuart.c	19 Oct 2006 17:41:12 -0000	1.9
@@ -8,7 +8,11 @@
  * This source code is hereby licensed to the Linux 2.4 kernel under the
  * GPL, and to Technologic Systems customers under the BSD license.
  *
+ * 2005-11-17:mos:initial version completed
+ * 2005-11-18:mos:added proper hardware flow control support (Tx)
+ * 2006-01-18:mos:cleanup;now using memory access instead of inb/outb
  */
+#include <linux/slab.h>
 #include <linux/config.h>
 #include <linux/module.h>
 #include <linux/tty.h>
@@ -19,6 +23,7 @@
 #include <linux/serial.h>
 #include <linux/console.h>
 #include <linux/sysrq.h>
+#include <linux/proc_fs.h>
 #include <asm/hardware.h>
 #include <asm/io.h>
 #include <asm/irq.h>
@@ -27,6 +32,7 @@
 #include <linux/ts_sbc.h>
 #include <asm/uaccess.h>
 
+#define DELAY_TIME      HZ / 100        // 100 Hz
 #define UART_PORT_SIZE  64              // not used
 #define PORT_TSUART     55              // see include/linux/serial_core.c
 #define UART_NR		3
@@ -43,29 +49,26 @@
 #define CALLOUT_TSUART_MINOR	1
 #define CALLOUT_TSUART_NR	UART_NR
 
+#define TS_MODEL_REG 0x2000000
 #define TS_TTL_REG   0x2000000
-#define TSUART1_BASE 0x2400000
-#define TSUART2_BASE 0x3000000
-#define TSUART3_BASE 0x3400000
 #define TSUART_IRQ 32
 
-/*
- * Append any extra per-port data we need to the generic uart_port.
- */
-struct uart_tsuart_port {
-  struct uart_port	port;
-};
-
-#define MYPORT	struct uart_tsuart_port *my = (struct uart_tsuart_port *)port
+#define TSUART1_BASE 0x12400000
+#define TSUART2_BASE 0x13000000
+#define TSUART3_BASE 0x13400000
 
 //-----------------------
 // Forward Declarations <
 //-----------------------
 
-static struct uart_tsuart_port tsuart_ports[];
+static struct uart_port tsuart_ports[];
 static void tsuart_stop_tx(struct uart_port *port, unsigned int tty_stop);
-
+static struct timer_list timer;
+static int triuart = 0;
+static int timer_added = 0;
 //#define TSUART_DEBUG
+//#define TSUART_DEBUG_DATA
+//#define TSUART_STATS
 //-----------------------------------------------------------------------
 //                                                                      /
 // Interrupt Routines                                                   \_
@@ -133,55 +136,53 @@
 // Begin hardware access code <
 //-----------------------------
 
-
-static inline unsigned long tsuart_ADRS(int uartNum) {
-  if (uartNum == 1) {
-    return TS7XXX_IO8_BASE + TSUART1_BASE;
-  } else if (uartNum == 2) {
-    return TS7XXX_IO8_BASE + TSUART2_BASE;
-  } else if (uartNum == 3) {
-    return TS7XXX_IO8_BASE + TSUART3_BASE;
-  }
+static inline int get_ts_model(void) {
+  return (inw(TS7XXX_IO16_BASE + TS_MODEL_REG)) & 3;
 }
 
-static inline int get_tsuart_ttl() {
+static inline int get_tsuart_ttl(void) {
   unsigned char c;
   c = inb(TS7XXX_IO8_BASE + TS_TTL_REG);
-  printk("debug1:%02X\n",c);
   return c;
 }
 
 static inline void put_tsuart_ttl(int flag) {
   if (flag) {
     outb(get_tsuart_ttl() | 64,TS7XXX_IO8_BASE + TS_TTL_REG);
-    printk("debug2:%02X\n",inb(TS7XXX_IO8_BASE + TS_TTL_REG));
   } else {
     outb(get_tsuart_ttl() & (~64),TS7XXX_IO8_BASE + TS_TTL_REG);
-    printk("debug3:%02X\n",inb(TS7XXX_IO8_BASE + TS_TTL_REG));
   }
 }
 
 // read the TS UART STAT register for the specified UART
-static inline unsigned char get_tsuart_STAT(int uartNum) {
-  return inb(tsuart_ADRS(uartNum));
+static inline unsigned char get_tsuart_STAT(struct uart_port *port) {
+  unsigned char *STAT = (unsigned char *)port->membase;
+
+  return *STAT;
 }
 
 // write the TS UART STAT register for the specified UART
-static inline void put_tsuart_STAT(int uartNum,unsigned char value) {
-  outb(value,tsuart_ADRS(uartNum));
+static inline void put_tsuart_STAT(struct uart_port *port,unsigned char value) {
+  unsigned char *STAT = (unsigned char *)port->membase;
+
+  *STAT = value;
 }
 
 // read the TS UART RXDAT register for the specified UART
-static inline int get_tsuart_RXDAT(int uartNum) {
-  return inb(1+tsuart_ADRS(uartNum));
+static inline int get_tsuart_RXDAT(struct uart_port *port) {
+  unsigned char *DAT = (unsigned char *)port->membase;
+
+  return DAT[1];
 }
 
 // write the TS UART TXDAT register for the specified UART
-static inline void put_tsuart_TXDAT(int uartNum,unsigned char data) {
-  outb(data,1+tsuart_ADRS(uartNum));
+static inline void put_tsuart_TXDAT(struct uart_port *port,unsigned char data) {
+  unsigned char *DAT = (unsigned char *)port->membase;
+
+  DAT[1] = data;
 }
 
-static inline int get_tsuart_TRI() {
+static inline int get_tsuart_TRI(void) {
   return ((inw(TS7XXX_IO16_BASE + 0x2400000) & 1) == 1);
 }
 
@@ -197,13 +198,12 @@
 
 // process the byte in the lsb of data by sending it to the
 // appropriate OS buffers for the given TS UART UART
-static void tsuart_handleRx(int uartNum,int data) {
-  struct uart_port *port = (struct uart_port *)(tsuart_ports + uartNum - 1);
+static void tsuart_handleRx(struct uart_port *port,int data) {
   struct tty_struct *tty;
   unsigned int ch = data;
 
-#ifdef TSUART_DEBUG
-  printk("Rx%d:%02X%s\n",uartNum,ch,port->info?"":"?");
+#ifdef TSUART_DEBUG_DATA
+  printk("Rx%d:%02X%s\n",port->line,ch,port->info?"":"?");
 #endif
   if (!port->info) {
     return; 
@@ -217,34 +217,51 @@
     tty_flip_buffer_push(tty); 
   }
   tty_insert_flip_char(tty, ch, 0);
-  gotbytes[uartNum-1]++;
+  gotbytes[port->line]++;
   return; 
 }
 
 static unsigned int total_sent = 0;
-
+static inline int bit_CTS(unsigned char reg_value);
 // If there is data ready to be transmitted for the given UART,
 // then feed to the byte to the UART
-static void tsuart_try_handleTx(int uartNum) {
-  struct uart_port *port = (struct uart_port *)(tsuart_ports + uartNum - 1);
+static void tsuart_try_handleTx(struct uart_port *port) {
   struct circ_buf *xmit;
   unsigned int ch=0;
 
   if (!port->info) {
     return;
   }
+  if (port->info->flags & ASYNC_CTS_FLOW) {
+    if (bit_CTS(get_tsuart_STAT(port))) {
+      port->info->tty->hw_stopped = 0;
+    } else {
+      port->info->tty->hw_stopped = 1;
+      if (!timer_added) {
+	timer_added = 1;
+	//	printk("Adding timer (%d)\n",port->line);
+	timer.expires = jiffies + DELAY_TIME;
+	add_timer (&timer);
+      }
+    }
+  }
   xmit = &port->info->xmit;
   if (uart_circ_empty(xmit) || uart_tx_stopped(port)) {
+    /*
+    if (uart_tx_stopped(port)) {
+      printk("tx stop detected\n");
+    }
+    */
     tsuart_stop_tx(port,0);
     return;
   }
   // handle one character
   ch = xmit->buf[xmit->tail];
-#ifdef TSUART_DEBUG
-  printk("Tx%d:%02X%s\n",uartNum,ch,port->info?"":"?");
+#ifdef TSUART_DEBUG_DATA
+  printk("Tx%d:%02X%s\n",port->line,ch,port->info?"":"?");
 #endif
   total_sent++;
-  put_tsuart_TXDAT(uartNum,(unsigned char)ch);
+  put_tsuart_TXDAT(port,(unsigned char)ch);
   xmit->tail = (xmit->tail + 1) & (UART_XMIT_SIZE - 1);
   port->icount.tx++;
   // done handling one character
@@ -260,29 +277,6 @@
   }
 }
 
-// Convert a port structure to a UART number. Relies on the fact
-// that we store our UART port information in a particular order.
-// We could just as easily implement this using extra data in
-// our extended port structure that contained the uartNumber,
-// but this wouldn't necessarily detect an invalid port.
-// We should always be able to find a valid port, but in the
-// unlikely (impossible?) event that we do, we return a valid
-// port anyway, to avoid lots of ugly and unnecessary checks
-// and warning messages elsewhere.
-static int getUartNum(struct uart_port *port) {
-  if (port == (struct uart_port *)tsuart_ports) {
-    return 1;
-  } else if (port == (struct uart_port *)(tsuart_ports+1)) {
-    return 2;
-  } else if (port == (struct uart_port *)(tsuart_ports+2)) {
-    return 3;
-  } else {
-    printk("tsuart: unknown port %p (expecting %p+%dn)\n",
-	   port,tsuart_ports,sizeof(struct uart_tsuart_port));
-    return 3; // hopefully port 3 is the most obscure
-  }
-}
-
 
 //----------------------------
 // Begin FPGA dependant code <
@@ -369,50 +363,132 @@
   }
 }
 
+//-----------------------------------------------------------------------
+//                                                                      /
+// /proc Routines                                                       \_
+//                                                                      /
+//                                                                      \_
+//                                                                      /
+//                                                                      \_
+//-----------------------------------------------------------------------
+/*
+  The user can set COM3 to TTL levels as follows:
+    echo "1" > /proc/device/tsuart/com3ttl
+  The user can set COM3 to RS-232 levels as follows:
+    echo "0" > /proc/device/tsuart/com3ttl
+  The user can query the current status of COM3 as follows:
+    cat /proc/device/tsuart/com3ttl
+      "0" if COM3 is at RS-232 levels
+      "1" if COM3 is at TTL levels
+ */
+int procfile_read(char *buffer, 
+		  char **buffer_location, 
+		  off_t offset, 
+		  int buffer_length, 
+		  int *eof,
+		  void *data)
+{
+  if (offset > 0) {
+    *eof = 1;
+    return 0;
+  }
+  MOD_INC_USE_COUNT;
+  buffer[0] = (get_tsuart_ttl() & 64) ? '1' : '0';
+  *buffer_location = buffer;
+  *eof = 1;
+  MOD_DEC_USE_COUNT;
+
+  return 1;
+}
+
+int procfile_write(struct file *file,
+		   const char *buffer,
+		   unsigned long count,
+		   void *data) {
+  char tmp;
+
+  MOD_INC_USE_COUNT;
+  if (copy_from_user(&tmp,buffer,1)) {
+    return -EFAULT;
+  }
+  if (tmp == '1') {
+    put_tsuart_ttl(1);
+  } else if (tmp == '0') {
+    put_tsuart_ttl(0);
+  }
+  MOD_DEC_USE_COUNT;
+  return 1;
+}
+
+int procfile_init(void) {
+  struct proc_dir_entry *dir1,*file;
+
+  dir1 = proc_mkdir("driver/tsuart",NULL);
+  if (dir1 == NULL) { return -ENOMEM; }
+  
+  file = create_proc_entry("driver/tsuart/com3ttl",
+			   S_IWUSR |S_IRUSR | S_IRGRP | S_IROTH,
+			   NULL);
+  if (file == NULL) {
+    remove_proc_entry("driver/tsuart", NULL);
+    return -ENOMEM;
+  }
+  file->read_proc = procfile_read;
+  file->write_proc = procfile_write;
+  file->owner = THIS_MODULE;
+  return 0;
+}
+
+void procfile_exit(void) {
+  remove_proc_entry("driver/tsuart/com3ttl",NULL);
+  remove_proc_entry("driver/tsuart", NULL);
+}
+
+
 //---------------------
 // End dependant code <
 //---------------------
 
-int tsuart_sanity_check_STAT(int uartNum) {
+int tsuart_sanity_check_STAT(struct uart_port *port) {
   unsigned char stat;
 
-  stat = get_tsuart_STAT(uartNum);
-  put_tsuart_STAT(uartNum,stat | 0x0F);
-  return (stat == get_tsuart_STAT(uartNum));
+  stat = get_tsuart_STAT(port);
+  put_tsuart_STAT(port,stat | 0x0F);
+  return (stat == get_tsuart_STAT(port));
 }
 
-int tsuart_sanity_check_baud(int uartNum,int rate) {
+int tsuart_sanity_check_baud(struct uart_port *port,int rate) {
   unsigned char stat;
 
-  stat = get_tsuart_STAT(uartNum);
-  put_tsuart_STAT(uartNum,assign_bits_BAUD(stat,rate));
-  stat = get_tsuart_STAT(uartNum);
+  stat = get_tsuart_STAT(port);
+  put_tsuart_STAT(port,assign_bits_BAUD(stat,rate));
+  stat = get_tsuart_STAT(port);
   return (bits_BAUD(stat) == rate);
 }
 
 // Check if the given UART port looks sane.
-int tsuart_sanity_check(int uartNum) {
-  if (!tsuart_sanity_check_STAT(uartNum)) { return 0; }
-  if (!tsuart_sanity_check_baud(uartNum,2400)) { return 0; }
-  if (!tsuart_sanity_check_baud(uartNum,4800)) { return 0; }
-  if (!tsuart_sanity_check_baud(uartNum,9600)) { return 0; }
-  if (!tsuart_sanity_check_baud(uartNum,19200)) { return 0; }
-  if (!tsuart_sanity_check_baud(uartNum,38400)) { return 0; }
-  if (!tsuart_sanity_check_baud(uartNum,57600)) { return 0; }
-  if (!tsuart_sanity_check_baud(uartNum,115200)) { return 0; }
+int tsuart_sanity_check(struct uart_port *port) {
+  if (!tsuart_sanity_check_STAT(port)) { return 0; }
+  if (!tsuart_sanity_check_baud(port,2400)) { return 0; }
+  if (!tsuart_sanity_check_baud(port,4800)) { return 0; }
+  if (!tsuart_sanity_check_baud(port,9600)) { return 0; }
+  if (!tsuart_sanity_check_baud(port,19200)) { return 0; }
+  if (!tsuart_sanity_check_baud(port,38400)) { return 0; }
+  if (!tsuart_sanity_check_baud(port,57600)) { return 0; }
+  if (!tsuart_sanity_check_baud(port,115200)) { return 0; }
   return 1;
 }
 
 // Check if data is ready to be received from the specified UART
 // and if so, read it into the data location provided.
-static inline void tsuart_checkRx(int uartNum,int *data) {
-  int stat = get_tsuart_STAT(uartNum);
+static inline void tsuart_checkRx(struct uart_port *port,unsigned int *data) {
+  int stat = get_tsuart_STAT(port);
 
   if (bit_DR(stat)) {
     if (bit_OERR(stat)) {
       rxof++;
     }
-    *data = get_tsuart_RXDAT(uartNum);
+    *data = get_tsuart_RXDAT(port);
   }
 }
 
@@ -420,7 +496,7 @@
 
 // See if the given UART wants to transmit data, and if so, 
 // transmit data if any is ready to be sent.
-static inline void tsuart_checkHandleTx(int uartNum) {
+static inline void tsuart_checkHandleTx(struct uart_port *port) {
   int stat;
 
   // Check the STAT register, and if it says the transmit
@@ -435,50 +511,44 @@
   // well not do the more expensive operation.
   
   
-  stat = get_tsuart_STAT(uartNum);
+  stat = get_tsuart_STAT(port);
   if (bit_TBRE(stat)) { // if buffer empty, then try to send
-    tsuart_try_handleTx(uartNum);
+    tsuart_try_handleTx(port);
   }
 }
 
 // See if we read any data, and if so, pass it to the upper layers
-static inline void tsuart_try_handleRx(int uartNum,int data) {
+static inline void tsuart_try_handleRx(struct uart_port *port,int data) {
   if (data >= 0) {
-    tsuart_handleRx(uartNum,data);
+    tsuart_handleRx(port,data);
   }
 }
 
 /*
   Interrupt if we have only 1 UART
  */
-#ifdef TSUART_DEBUG
+#ifdef TSUART_STATS
 int stats[256];
 #endif
 
 static void tsuart_int1(int irq, void *dev_id, struct pt_regs *regs) {
-  int data1,data2,data3,counter=256;
+  unsigned int data1,counter=256;
+  struct uart_port *port = (struct uart_port *)(tsuart_ports);
 
   gotbytes[0] = 0;
   while (--counter) {
-    data1 = data2 = data3 = -1;
-    tsuart_checkRx(1,&data1);
-    //    tsuart_checkRx(2,&data2);
-    //    tsuart_checkRx(3,&data3);
-    if (data1 == -1 && data2 == -1 && data3 == -1) {
+    data1 = -1;
+    tsuart_checkRx(port,&data1);
+    if (data1 == -1) {
       break;
     }
-    tsuart_try_handleRx(1,data1);
-    //    tsuart_try_handleRx(2,data2);
-    //    tsuart_try_handleRx(3,data3);
+    tsuart_try_handleRx(port,data1);
   }
   if (counter < mincounter) { mincounter = counter; }
-  tsuart_checkHandleTx(1);
-  //  tsuart_checkHandleTx(2);
-  //  tsuart_checkHandleTx(3);
+  tsuart_checkHandleTx(port);
   if (gotbytes[0]) {
-    struct uart_port *port = (struct uart_port *)(tsuart_ports);
     struct tty_struct *tty = port->info->tty;
-#ifdef TSUART_DEBUG
+#ifdef TSUART_STATS
     stats[gotbytes[0]-1]++;
 #endif
     tty_flip_buffer_push(tty);
@@ -490,39 +560,39 @@
  */
 static void tsuart_int3(int irq, void *dev_id, struct pt_regs *regs) {
   struct uart_port *port = (struct uart_port *)(tsuart_ports);
-  int data1,data2,data3,counter=256;
+  unsigned int data1,data2,data3,counter=256;
 
   gotbytes[0] = gotbytes[1] = gotbytes[2] = 0;
   while (--counter) {
     data1 = data2 = data3 = -1;
-    tsuart_checkRx(1,&data1);
-    tsuart_checkRx(2,&data2);
-    tsuart_checkRx(3,&data3);
+    tsuart_checkRx(port,&data1);
+    tsuart_checkRx(port+1,&data2);
+    tsuart_checkRx(port+2,&data3);
     if (data1 == -1 && data2 == -1 && data3 == -1) {
       break;
     }
-    tsuart_try_handleRx(1,data1);
-    tsuart_try_handleRx(2,data2);
-    tsuart_try_handleRx(3,data3);
+    tsuart_try_handleRx(port,data1);
+    tsuart_try_handleRx(port+1,data2);
+    tsuart_try_handleRx(port+2,data3);
   }
   if (counter < mincounter) { mincounter = counter; }
-  tsuart_checkHandleTx(1);
-  tsuart_checkHandleTx(2);
-  tsuart_checkHandleTx(3);
+  tsuart_checkHandleTx(port);
+  tsuart_checkHandleTx(port+1);
+  tsuart_checkHandleTx(port+2);
   if (gotbytes[0]) {
-#ifdef TSUART_DEBUG
+#ifdef TSUART_STATS
     stats[gotbytes[0]-1]++;
 #endif
     tty_flip_buffer_push(port->info->tty);
   }
   if (gotbytes[1]) {
-#ifdef TSUART_DEBUG
+#ifdef TSUART_STATS
     stats[gotbytes[1]-1]++;
 #endif
     tty_flip_buffer_push((port+1)->info->tty);
   }
   if (gotbytes[2]) {
-#ifdef TSUART_DEBUG
+#ifdef TSUART_STATS
     stats[gotbytes[2]-1]++;
 #endif
     tty_flip_buffer_push((port+2)->info->tty);
@@ -549,9 +619,9 @@
 static void tsuart_start_tx(struct uart_port *port, unsigned int tty_start)
 {
 #ifdef TSUART_DEBUG
-  //  printk("tsuart_start_tx\n");
+  printk("tsuart_start_tx\n");
 #endif
-  tsuart_checkHandleTx(getUartNum(port));
+  tsuart_checkHandleTx(port);
 }
 
 static void tsuart_stop_rx(struct uart_port *port)
@@ -570,25 +640,43 @@
 
 static unsigned int tsuart_tx_empty(struct uart_port *port)
 {
-  return bit_TBRE(get_tsuart_STAT(getUartNum(port)));
+#ifdef TSUART_DEBUG
+  printk("tsuart_tx_empty called,port=%p\n",port);
+#endif
+  return bit_TBRE(get_tsuart_STAT(port));
 }
 
 static unsigned int tsuart_get_mctrl(struct uart_port *port)
 {
   unsigned int result = 0;
 
+#ifdef TSUART_DEBUG
+  printk("tsuart_get_mctrl called,port=%p\n",port);
+#endif
+
   result |= TIOCM_CAR;  // pretend DCD is always set
   result |= TIOCM_DSR;  // pretend DSR is always set
-  if (bit_CTS(get_tsuart_STAT(getUartNum(port)))) {
+  if (bit_CTS(get_tsuart_STAT(port))) {
+#ifdef TSUART_DEBUG
+    printk("reporting CTS asserted\n");
+#endif
     result |= TIOCM_CTS;
+  } else {
+#ifdef TSUART_DEBUG
+    printk("reporting CTS de-asserted\n");
+#endif
   }
   return result;
 }
 
 static void tsuart_set_mctrl(struct uart_port *port, unsigned int mctrl)
 {
-  put_tsuart_STAT(getUartNum(port),
-   assign_bit_RTS(get_tsuart_STAT(getUartNum(port)),(mctrl&TIOCM_RTS)==0));
+#ifdef TSUART_DEBUG
+  printk("tsuart_set_mctrl called,port=%p,mctrl=%X\n",port,mctrl);
+  printk("RTS=%d\n",((mctrl&TIOCM_RTS) != 0) ? 1:0);
+#endif
+  put_tsuart_STAT(port,
+		  assign_bit_RTS(get_tsuart_STAT(port),(mctrl&TIOCM_RTS)!=0));
   // No support for TIOCM_DTR, so ignore it
 }
 
@@ -602,16 +690,32 @@
 
 static int started = 0;
 
+static void tsuart_cts_timer(unsigned long data) {
+  struct uart_port *port = (struct uart_port *)(tsuart_ports);
+  //  struct uart_port *port = (struct uart_port *)data;
+  //  printk("timer fired!\n");
+  timer_added = 0;
+  tsuart_checkHandleTx(port);
+  tsuart_checkHandleTx(port+1);
+  tsuart_checkHandleTx(port+2);
+}
+
 static int tsuart_startup(struct uart_port *port)
 {
-  unsigned char ch;
-  unsigned long base_addr;
-  int i,triuart=0;
+  struct uart_port *ports = (struct uart_port *)(tsuart_ports);
+#ifdef TSUART_STATS
+  int i;
+#endif
 
   if (started++) {
     return 0;
   }
-#ifdef TSUART_DEBUG
+
+  /* create our timer but don't submit it just yet */
+  timer.data = (unsigned long )port;
+  timer.function = tsuart_cts_timer;
+
+#ifdef TSUART_STATS
   for (i=0;i<256;i++) {
     stats[i] = 0;
   }
@@ -619,36 +723,44 @@
   rxof = 0;
 #ifdef TSUART_DEBUG
   printk("tsuart_startup called, irq=%d\n",port->irq);
-  printk("membase=%p\nmapbase=%p\n",port->membase,port->mapbase);
+  printk("membase=%p\nmapbase=%lX\n",port->membase,port->mapbase);
 #endif
   triuart = get_tsuart_TRI();
 #ifdef TSUART_DEBUG
   printk("tsuart:detected %d UARTs\n",triuart?3:1);
 #endif
-  if (triuart && !tsuart_sanity_check(2)) {
+  if (triuart && !tsuart_sanity_check(ports)) {
+    printk("tsuart: 1 uart sanity checked failed!\n");
+    triuart = 0;
+  }
+  if (triuart && !tsuart_sanity_check(ports+1)) {
     printk("tsuart: 3 uart sanity checked failed, falling back to 1 UART\n");
     triuart = 0;
   }
-  if (triuart && !tsuart_sanity_check(3)) {
+  if (triuart && !tsuart_sanity_check(ports+2)) {
     printk("tsuart: 3 uart sanity checked failed, falling back to 1 UART\n");
     triuart = 0;
   }
   if (!triuart) {
-    return request_irq(port->irq, tsuart_int1, 0, "tsuart_uarts", port);
+    return request_irq(port->irq, tsuart_int1, SA_SHIRQ, "tsuart_uarts", port);
   } else {
-    return request_irq(port->irq, tsuart_int3, 0, "tsuart_uarts", port);
+    return request_irq(port->irq, tsuart_int3, SA_SHIRQ, "tsuart_uarts", port);
   }
   return 0;
 }
 
 static void tsuart_shutdown(struct uart_port *port)
 {
+#ifdef TSUART_STATS
   int i;
+#endif
 
   if (--started) {
     return;
   }
-#ifdef TSUART_DEBUG
+  del_timer (&timer);
+  timer_added = 0;
+#ifdef TSUART_STATS
   for (i=0;i<6;i++) {
     printk("tsuart@%d:%d\n",i+1,stats[i]);
   }
@@ -657,8 +769,7 @@
   printk("tsuart:overflows=%d\n",rxof);
   printk("tsuart_shutdown called, irq=%d\n",port->irq);
 #endif
-  put_tsuart_STAT(getUartNum(port),
-		  assign_bits_BAUD(get_tsuart_STAT(getUartNum(port)),0));
+  put_tsuart_STAT(port,assign_bits_BAUD(get_tsuart_STAT(port),0));
 
   free_irq(port->irq,port);
   // Since there is no way to disable the UARTs from
@@ -684,22 +795,15 @@
   default: baud=0;
   }
   if (baud) {
-    printk("tsuart:change_speed (%d): %d\n",getUartNum(port),baud);
-    put_tsuart_STAT(getUartNum(port),
-		    assign_bits_BAUD(get_tsuart_STAT(getUartNum(port)),baud));
+    printk("tsuart:change_speed, port %d: %d bad\n",port->line,baud);
+    put_tsuart_STAT(port,assign_bits_BAUD(get_tsuart_STAT(port),baud));
   } else {
-    printk("tsuart:unknown change_speed (%d): %X\n",getUartNum(port),encoded_baud);
+    printk("tsuart:unknown change_speed, port %d: %X\n",port->line,encoded_baud);
     printk("%08X & %08X -> %08X\n",cflag,CBAUD,cflag & CBAUD);
   }
 
-  if (getUartNum(port) == 1) {
-    if (cflag & PARODD) {
-      printk("ttyTS1:TTL\n");
-      put_tsuart_ttl(1);
-    } else {
-      printk("ttyTS1:RS-232\n");
-      put_tsuart_ttl(0);
-    }
+  if (cflag & PARENB) {
+    printk("tsuart:parity unsupported, using no parity\n");
   }
   /* byte size and parity */
   switch (cflag & CSIZE) {
@@ -728,7 +832,13 @@
  */
 static void tsuart_release_port(struct uart_port *port)
 {
+#ifdef TSUART_DEBUG
+  printk("tsuart_release_port called, membase=%p\n",port->membase);
+#endif
   //  release_mem_region(port->mapbase, UART_PORT_SIZE);
+  __iounmap(port->membase);
+
+  port->membase = 0;
 }
 
 /*
@@ -736,6 +846,17 @@
  */
 static int tsuart_request_port(struct uart_port *port)
 {
+#ifdef TSUART_DEBUG
+  printk("tsuart_request_port called, mapbase=%lX\n",port->mapbase);
+#endif
+  // call __ioremap to avoid a IO to PHY translation - we already have
+  // the PHYsical address!
+  port->membase = __ioremap(port->mapbase, 4096,0);
+  if (!port->membase) {
+    printk(KERN_ERR "tsuart: cannot map io memory\n");
+    return -ENOMEM;
+  }
+  return 0;
   //  return request_mem_region(port->mapbase, UART_PORT_SIZE, "tsuart_uarts")
   //			!= NULL ? 0 : -EBUSY;
 }
@@ -805,45 +926,39 @@
 	.ioctl		= tsuart_ioctls,
 };
 
-static struct uart_tsuart_port tsuart_ports[3] = {
+static struct uart_port tsuart_ports[3] = {
 	{
-		.port	= {
-			.membase	= (void *)IO_ADDRESS(TSUART1_BASE),
-			.mapbase	= TSUART1_BASE,
-			.iotype		= SERIAL_IO_MEM,
-			.irq		= TSUART_IRQ,
-			.uartclk	= UART_CLOCK,
-			.fifosize	= UART_FIFOSIZE,
-		    	.ops		= &tsuart_ops,
-		    	.flags		= ASYNC_BOOT_AUTOCONF,
-			.line		= 0,
-        	},
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 0,
 	},
 	{
-		.port	= {
-			.membase	= (void *)IO_ADDRESS(TSUART2_BASE),
-			.mapbase	= TSUART2_BASE,
-			.iotype		= SERIAL_IO_MEM,
-			.irq		= TSUART_IRQ,
-			.uartclk	= UART_CLOCK,
-			.fifosize	= UART_FIFOSIZE,
-			.ops		= &tsuart_ops,
-			.flags		= ASYNC_BOOT_AUTOCONF,
-			.line		= 1,
-		},
+	  .membase	= 0,
+	  .mapbase	= TSUART2_BASE,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 1,
 	},
 	{
-		.port	= {
-			.membase	= (void *)IO_ADDRESS(TSUART3_BASE),
-			.mapbase	= TSUART3_BASE,
-			.iotype		= SERIAL_IO_MEM,
-			.irq		= TSUART_IRQ,
-			.uartclk	= UART_CLOCK,
-			.fifosize	= UART_FIFOSIZE,
-			.ops		= &tsuart_ops,
-			.flags		= ASYNC_BOOT_AUTOCONF,
-			.line		= 2,
-		},
+	  .membase	= 0,
+	  .mapbase	= TSUART3_BASE,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 2,
 	}
 };
 
@@ -873,16 +988,26 @@
 	.cons			= NULL,
 };
 
+
 static int __init tsuart_init(void)
 {
-	int ret;
-
+	int ret,i;
+	
+	if (get_ts_model() != 2) {
+	    printk("tsuart not loading: ts7260 board not detected\n");
+	    procfile_exit();
+	    return -1;
+	}
 	ret = uart_register_driver(&tsuart_reg);
 	if (ret == 0) {
-		int i;
+		ret = procfile_init();
+		if (ret) {
+			uart_unregister_driver(&tsuart_reg);
+	  		return ret;
+		}
 
 		for (i=0;i<UART_NR;i++)
-			uart_add_one_port(&tsuart_reg,&tsuart_ports[i].port);
+			uart_add_one_port(&tsuart_reg,&tsuart_ports[i]);
 	}
 	return ret;
 }
@@ -891,8 +1016,9 @@
 {
 	int i;
 
+	procfile_exit();
 	for (i=0;i<UART_NR;i++)
-		uart_remove_one_port(&tsuart_reg, &tsuart_ports[i].port);
+		uart_remove_one_port(&tsuart_reg, &tsuart_ports[i]);
 
 	uart_unregister_driver(&tsuart_reg);
 }
Index: drivers/serial/tsuart.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart.h,v
retrieving revision 1.1
retrieving revision 1.10
diff -u -r1.1 -r1.10
--- drivers/serial/tsuart.h	16 May 2006 19:09:37 -0000	1.1
+++ drivers/serial/tsuart.h	23 Apr 2008 20:38:38 -0000	1.10
@@ -3,6 +3,8 @@
 #define PORT_STATUS_PAR 4
 #define PORT_STATUS_PARODD 8
 #define PORT_STATUS_8PLUS1 16
+#define PORT_STATUS_SHIRQ 32
+#define PORT_STATUS_PARITY 128
 struct tsuart_port {
   struct uart_port u;
   struct tsuart_port *nextd; // next tsuart_port with different IRQ
@@ -18,6 +20,9 @@
   struct uart_driver *driver;
   unsigned *parity;
   int dataMask,dataMask2;
+  int boardId; // gives us a way to associate a port with a board
+  int (*mdmctrl)(struct tsuart_port *,int cmd);
+  unsigned int old_status;
 };
 #define TSPORT(port) ((struct tsuart_port *)port)
 
@@ -49,6 +54,10 @@
   return (reg_value & 0x08) == 0x08;
 }
 
+static inline unsigned bit_RXBRK(unsigned reg_value) {
+  return (reg_value & 0x0200) == 0x0200;
+}
+
 // accepts the value read from the TS UART STAT register
 // returns TRUE if the RTS bit is set, and FALSE if it is clear
 static inline int bit_RTS(unsigned char reg_value) {
@@ -62,6 +71,10 @@
   return (reg_value & ~0x10) | (set ? 0x10 : 0);
 }
 
+static inline unsigned assign_bit_TXBRK(unsigned reg_value,int set) {
+  return (reg_value & ~0x400) | (set ? 0x400 : 0);
+}
+
 static inline unsigned short assign_bit_MODE9(unsigned reg_value,int set)
 {
   return (reg_value & ~0x100) | (set ? 0x100 : 0);
@@ -92,7 +105,9 @@
 #define TS_MODEL_7250 1
 #define TS_MODEL_7260 2
 #define TS_MODEL_7300 3
+#define TS_MODEL_7400 4
 #define TS_MODEL_JNS200 6
+#define TS_MODEL_PAC4 2  // really going to be 5 
 
 static inline int get_ts_model(void) {
   return (inw(TS7XXX_IO16_BASE + TS_MODEL_REG)) & 7;
@@ -102,7 +117,7 @@
 // 1. We want to share the code among all driver modules
 // 2. We don't want to put it in the core module, as its initialization
 #ifndef TSUART_CORE
-inline void init_tsuart_port(struct tsuart_port *p) {
+static inline void init_tsuart_port(struct tsuart_port *p) {
   p->u.irq = 0;
   p->u.uartclk = UART_CLOCK;
   p->u.fifosize = UART_FIFOSIZE;
@@ -123,5 +138,7 @@
   p->dataMask = p->dataMask2 = 0xFF;
   p->localStatus = 0;
   p->portStatus = 0;
+  p->boardId = 0;
+  p->mdmctrl = 0;
 }
 #endif
